From: Milan Broz <mbroz@redhat.com>

Remove max_sector restriction, merge function replaced it.

Signed-off-by: Milan Broz <mbroz@redhat.com>
Signed-off-by: Alasdair G Kergon <agk@redhat.com>

---

 drivers/md/dm-table.c |   13 ++++++-------
 1 files changed, 6 insertions(+), 7 deletions(-)

Index: linux-2.6.23/drivers/md/dm-table.c
===================================================================
--- linux-2.6.23.orig/drivers/md/dm-table.c	2007-10-13 06:48:24.000000000 +0100
+++ linux-2.6.23/drivers/md/dm-table.c	2007-10-13 06:48:55.000000000 +0100
@@ -538,14 +538,13 @@ void dm_set_device_limits(struct dm_targ
 	rs->max_sectors =
 		min_not_zero(rs->max_sectors, q->max_sectors);
 
-	/* FIXME: Device-Mapper on top of RAID-0 breaks because DM
-	 *        currently doesn't honor MD's merge_bvec_fn routine.
-	 *        In this case, we'll force DM to use PAGE_SIZE or
-	 *        smaller I/O, just to be safe. A better fix is in the
-	 *        works, but add this for the time being so it will at
-	 *        least operate correctly.
+	/*
+	 * Check if merge fn is supported.
+	 * If not we'll force DM to use PAGE_SIZE or
+	 * smaller I/O, just to be safe.
 	 */
-	if (q->merge_bvec_fn)
+
+	if (q->merge_bvec_fn && !ti->type->merge)
 		rs->max_sectors =
 			min_not_zero(rs->max_sectors,
 				     (unsigned int) (PAGE_SIZE >> 9));
